
#define MAX_ROOTS_SIZE (1024*1024)

#define MAX_RB_ELEMENTS (1024*1024)

#define MAX_FREE_ELEMENTS (1024*1024)

#define SNAPSHOT_COPY_SIZE (16*1024)
#define SNAPSHOT_DIVIDE "4"

#define POOL_SIZE_FACTOR 0.5

#define NOT_FOUND_POINTER ((void*)-1)

#define NDEBUG 1


// Whether to free memory during alloc or during free.
// During alloc is better for cache, during free is better for CPU.
// (benchmarks show minimal difference)
#define CLEAR_MEMORY_DURING_ALLOCATION 0


// Turns on benchmarking. Uses TSC, so it should not affect
// performance to turn it on.
#define BENCHMARK 1


// Turns the gc into a fairly traditional non-realtime mark-and-sweep collector.
#define NO_SNAPSHOT 0


// I get a 16% decrease in snapshot time on an intel dual core 2 computer setting
// this to 1. Whether the combined extra spent time is wasted or not, I don't
// know. Because of this combined with uncertainty about realtime behaviour of doing snapshots
// in parallel, PARALLEL_SNAPSHOT is set to 0 by default.
#define PARALLEL_SNAPSHOT 0


// Significantly improves performance and consistant CPU time for NO_SNAPSHOT. If not, only a small difference.
#define BOUND_THREADS_TO_ONE_CPU 1


// For debugging. Significantly lowers the performance.
#define ALWAYS_FULL_SNAPSHOT 0

// Only for debugging. Not sure the gc behaves strictly correct when this one is set.
//#define DEBUG_DOUBLEFREE 1
