
#ifdef USE_TLSF




#include <tlsf.h>

typedef void* memtype_t;

static void *CREATE_MEMHEAP(size){
  void *ret=my_calloc(size);
  init_memory_pool(size,ret);
  return ret;
}

#define FREE_MEMHEAP(heap) free(heap)

#define FREE_MEM(heap,start,size) free_ex(mem,start)

#define CALLOC_MEM(heap,size1,size2) calloc_ex(size1,size2,heap)
#define MALLOC_MEM(heap,size) malloc_ex(size,heap)

#define GET_RAW_MEM(heap) heap

#define GET_CONT_HEAP_SIZE(heap,maximum) maximum




#else // !USE_TLSF



#define ST static

#include "poolmemalloc.c"

typedef poolmem_t* memtype_t;

#define CREATE_MEMHEAP(size) poolmem_create(size,NULL,max_mem_size)
#define FREE_MEMHEAP(heap) poolmem_delete(heap)

#define FREE_MEM(heap,start,size) poolmem_free(heap,start,size)

ST void *CALLOC_MEM(memtype_t heap,size_t size1,size_t size2){
  size_t size=size1*size2;
  void *ret=poolmem_alloc(heap,size);
  if(ret!=NULL)
    memset(ret,0,size);
  return ret;
}

#define MALLOC_MEM(heap,size) poolmem_alloc(heap,size)

#define GET_RAW_MEM(heap) ((poolmem_t*)heap)->mem

#define GET_CONT_HEAP_SIZE(heap,maximum) ( (heap)->mem_free - (heap)->mem )

#define GET_CONT_HEAP_END(heap,maximum)  ((char*)(heap)->mem_free)

#endif // !USE_TLSF
